
bl_info = {
	"name": "Node Group Users",
	"author": "",
	"version": (1, 0, 0),
	"blender": (2, 7, 9),
	"location": "Node Editor > Properties > Properties Panel",
	"description": "Gets the material users of the active or all node groups.",
	"warning": "",
	"category": "Node"
}


import bpy


####################################################################################################################
panel_type_node_group = "NODE_PT_active_node_properties"

def node_group_users(self, context):
	layout = self.layout
	col1 = layout.column(align=True)
	act_mat = bpy.context.object.active_material
	node_trees = act_mat.node_tree
	act_node = node_trees.nodes.active

	if act_node.type == 'GROUP':			
		col1.prop(context.scene, "node_group_materials", text='Users', icon='NODETREE', toggle=True)

		if context.scene.node_group_materials == True:
			
			col1_row = col1.row(align=True)
			col1_row.prop(context.scene, "node_group_label", text='Show Label')
			col1_row.prop(context.scene, "node_group_linked", text='Show Linked')
			col1_row.prop(context.scene, "node_group_all", text='Show All')

##########################################################################################################################################
#Displays the selected node group
		if context.scene.node_group_all == False and context.scene.node_group_materials == True:
				
			row1 = layout.row(align=True)
			row1.label('Material:')
			if context.scene.node_group_label == True:
				row1.label('Node Label:')
			if context.scene.node_group_linked == True:
				row1.label('Linked Outputs:')

			col = layout.column(align=True)
			col.separator()

			act_mat = bpy.context.object.active_material
			node_trees = act_mat.node_tree
			act_node = node_trees.nodes.active
			 
			for groups in bpy.data.node_groups:
				group_name = groups.name
			if act_node.select == True and bpy.data.node_groups[group_name].users >= 1: 

				for material in bpy.data.materials:
					mat_name = material.name
					for mat_nodes in material.node_tree.nodes:
						if mat_nodes.type == 'GROUP' and material.node_tree.nodes[mat_nodes.name].node_tree == act_node.node_tree:
							#print(mat_name)
							if context.scene.node_group_linked == True: 	
								box = layout.box()  
								row = box.row(align=True)
	
							if context.scene.node_group_linked == False:		  
								row = col.row(align=True)
																	   
							row.label(material.name, icon_value= layout.icon(material))
							#row.label(group_name, icon='NODETREE')


							if context.scene.node_group_label == True:    
								if mat_nodes.label != '':
									row.label(mat_nodes.label, icon='NODE')
								if mat_nodes.label == '':
									row.label('None', icon='BLANK1')


							if context.scene.node_group_linked == True:
								col2 = row.column(align=True)      

								for all_linked in mat_nodes.outputs:		
									if all_linked.is_linked == True:
										col2.label(all_linked.name, icon='LINKED')
									if all_linked.is_linked == False:
										col2.label("None", icon='BLANK1')
##########################################################################################################################################
#Displays all node groups
		if context.scene.node_group_all == True and context.scene.node_group_materials == True:
					
			row1 = layout.row(align=True)
			row1.label('Material:')
			row1.label('Node Group:')
			if context.scene.node_group_label == True:
				row1.label('Node Label:')
			if context.scene.node_group_linked == True:
				row1.label('Linked Outputs:')

			col = layout.column(align=True)
			col.separator()
			 
			for groups in bpy.data.node_groups:
				group_name = groups.name 
				if bpy.data.node_groups[group_name].users >= 1:
					for material in bpy.data.materials:
						for mat_nodes in material.node_tree.nodes:  
							if mat_nodes.type == 'GROUP' and material.node_tree.nodes[mat_nodes.name].node_tree == bpy.data.node_groups[group_name]:
		
								if context.scene.node_group_linked == True: 	
									box = layout.box()  
									row = box.row(align=True)
	
								if context.scene.node_group_linked == False:		  
									row = col.row(align=True)
									   
								row.label(material.name, icon_value= layout.icon(material))
								row.label(group_name, icon='NODETREE')


								if context.scene.node_group_label == True:    
									if mat_nodes.label != '':
										row.label(mat_nodes.label, icon='NODE')
									if mat_nodes.label == '':
										row.label('None', icon='BLANK1')


								if context.scene.node_group_linked == True:
									col2 = row.column(align=True)      
									#for all_linked in mat_nodes.outputs:
										#col2.label("%s" % all_linked.is_linked + " / " + all_linked.name, icon='LINKED')
									for all_linked in mat_nodes.outputs:		
										if all_linked.is_linked == True:
											col2.label(all_linked.name, icon='LINKED')
										if all_linked.is_linked == False:
											col2.label("None", icon='BLANK1')   	   
####################################################################################################################

def register(): 
	
	if hasattr(bpy.types, panel_type_node_group):
		getattr(bpy.types, panel_type_node_group).append(node_group_users)

	bpy.types.Scene.node_group_materials = bpy.props.BoolProperty(
		default = True,
		description = 'Gets the material users of the active or all node groups.',
		)
	bpy.types.Scene.node_group_label = bpy.props.BoolProperty(
		default = False,
		description = 'Shows the label of the node groups.',
		)
	bpy.types.Scene.node_group_linked = bpy.props.BoolProperty(
		default = False,
		description = 'Shows if the node groups are linked.',
		)
	bpy.types.Scene.node_group_all = bpy.props.BoolProperty(
		default = False,
		description = 'Displays all node groups.',
		)

def unregister():

	if hasattr(bpy.types, panel_type_node_group):
		getattr(bpy.types, panel_type_node_group).remove(node_group_users)

	del bpy.types.Scene.node_group_materials
	del bpy.types.Scene.node_group_label
	del bpy.types.Scene.node_group_linked
	del bpy.types.Scene.node_group_all

if __name__ == "__main__":
	register()



